program Linear_shift
  use sep
  use axisIO

  implicit none


  integer :: naxis,n1,n2,i,j
  type(myaxis)  axis1, axis2, axis3
  ! <in.H bubble > out.H pad=pad_times
  ! pad_times means to pad as n times as input length 0 after input data BEFORE inverse.
  !           That will affect the negtive time casued the Periodicity

  real, dimension(:,:), allocatable :: d,output
  character(len=256) :: csz_shift_file
  character(len=256) :: shift_file
  real,allocatable :: shift(:)
  integer :: n_shift,int_shift
  integer :: n2_org,shift_2d

  csz_shift_file="shift"
   !Params
  call sep_init()

  call from_param (csz_shift_file, shift_file, 'NULL')
  call from_param ('2d_shift_file', shift_2d, 0)

  write(0,*) 'Usage: Linear_shift.x < > shift=file_name 2d_shift_file=[0,1]'

  call assert(shift_file.ne.'NULL','Assert failed: shift_file.eq.''NULL'' ')

  call hinaxis(axis1,1)
  call hinaxis(axis2,2)
  call hinaxis(axis3,3)
!   n2=n2*axis3%n



  n1 = axis1%n; n2 = axis2%n
  n2_org=n2
  if (axis3%n .gt. 1) then
    n2=n2*axis3%n
  end if


  call hinaxis(axis1,1,shift_file)
  call hinaxis(axis2,2,shift_file)
  call hinaxis(axis3,3,shift_file)

  n_shift = axis1%n
  if (axis2%n .gt. 1) then
    n_shift=n_shift*axis2%n
  end if

  write(0,*) n2,n2_org,shift_2d

  call assert(axis3%n.eq.1,'Assert failed: axis3%n.eq.1')
  call assert(n_shift.eq.n2 .and. shift_2d.eq.0 .or. n_shift.eq.n2_org .and. shift_2d.eq.1 ,'n_shift.eq.n2 .and. shift_2d.eq.0 .or. n_shift.eq.n2_org .and. shift_2d.eq.1')


  write(0,*) "Usage: <in.H Linear_shift.x > out.H shift=shift_file"




  if (n1.le.1 .and. n2.le.1) then
    write(0,*) "n1 and n2 <= 0"
    stop
  end if

  allocate (d(n1,n2))
  allocate (output(n1,n2),shift(n2))

  d=0
  output=0
 

  call sep_read(d)
  call sep_read(shift,shift_file)

 
  do i=1,n2
    if (shift_2d.eq.1) then
      int_shift=shift(mod(i-1,n2_org)+1)+0.5
    else
      int_shift=shift(i)+0.5
    end if

    do j=max(1,1+int_shift),min(n1,n1+int_shift)
      output(j,i)=d(j-int_shift,i)
    end do
  end do


  call sep_write(output)
  deallocate(d,output,shift)

  call sep_close()
end program

SUBROUTINE assert(expression,string)
  implicit none
  logical 	:: expression
  character (len=*) :: string
  if (expression.eq..false.) then
    call erexit(string)
  end if
end SUBROUTINE
