#include <stdio.h>
#include "alloc.h"

float **malloc2float(size_t ns,size_t nf)
{
    float **buf;
    size_t idx;
    buf=(float**)malloc(sizeof(float*)*ns);
    assert(buf);
    buf[0]=(float*)malloc(sizeof(float)*ns*nf);
    memset((void*)buf[0],'\0',sizeof(float)*ns*nf);
    for (idx=1;idx<ns;idx++)
    {
        buf[idx]=buf[idx-1]+nf;
    }
    return buf;
}

void free2float(float ** buf)
{
    if (!buf) return;
    assert(buf[0]);
    free(buf[0]);
    free(buf);
}


float ***malloc3float(size_t ns,size_t nm,size_t nf)
{
    float ***buf;
    size_t i;
    buf=(float***)malloc(sizeof(float**)*ns);
    assert(buf);
    buf[0]=(float**)malloc(sizeof(float*)*ns*nm);
    assert(buf[0]);
    buf[0][0]=(float*)malloc(sizeof(float)*ns*nm*nf);
    memset((void*)buf[0][0],'\0',sizeof(float)*ns*nm*nf);
    for (i=1;i<ns;i++)
    {
        buf[i]=buf[i-1]+nm;
    }
    for (i=1;i<ns*nm;i++)
    {
        buf[0][i]=buf[0][i-1]+nf;
    }
    return buf;
}

void free3float(float *** buf)
{
    if (!buf) return;
    assert(buf[0][0]);
    free(buf[0][0]);
    assert(buf[0]);
    free(buf[0]);
    free(buf);
}

double **malloc2double(size_t ns,size_t nf)
{
    double **buf;
    size_t idx;
    buf=(double**)malloc(sizeof(double*)*ns);
    assert(buf);
    buf[0]=(double*)malloc(sizeof(double)*ns*nf);
    memset((void*)buf[0],'\0',sizeof(double)*ns*nf);
    for (idx=1;idx<ns;idx++)
    {
        buf[idx]=buf[idx-1]+nf;
    }
    return buf;
}

void free2double(double ** buf)
{
    if (!buf) return;
    assert(buf[0]);
    free(buf[0]);
    free(buf);
}
